# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTIBILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

bl_info = {
    "name" : "AutoDepth AI",
    "author" : "Blender Procedural", 
    "description" : "",
    "blender" : (4, 0, 0),
    "version" : (1, 0, 1),
    "location" : "",
    "warning" : "",
    "doc_url": "", 
    "tracker_url": "", 
    "category" : "3D View" 
}


import bpy
import bpy.utils.previews
import os
from bpy_extras.io_utils import ImportHelper, ExportHelper
import mathutils
import subprocess
import importlib
from bpy.app.handlers import persistent
import threading
from .translation import translate


addon_keymaps = {}
_icons = None
depthgen = {'sna_check': 0, }


def property_exists(prop_path, glob, loc):
    try:
        eval(prop_path, glob, loc)
        return True
    except:
        return False


def load_preview_icon(path):
    global _icons
    if not path in _icons:
        if os.path.exists(path):
            _icons.load(path, path, "IMAGE")
        else:
            return 0
    return _icons[path].icon_id


def sna_update_sna_inputpath_5D51D(self, context):
    sna_updated_prop = self.sna_inputpath
    bpy.ops.image.open(filepath=bpy.context.scene.sna_inputpath)
    print((os.path.basename(bpy.context.scene.sna_inputpath)[:63] if (len(os.path.basename(bpy.context.scene.sna_inputpath)) > 63) else os.path.basename(bpy.context.scene.sna_inputpath)))
    filepath_E3D8B = bpy.data.images[(os.path.basename(bpy.context.scene.sna_inputpath)[:63] if (len(os.path.basename(bpy.context.scene.sna_inputpath)) > 63) else os.path.basename(bpy.context.scene.sna_inputpath))].filepath_from_user()
    bpy.context.scene.sna_abspath = filepath_E3D8B
    print(os.path.basename(bpy.context.scene.sna_inputpath), filepath_E3D8B)


def sna_update_sna_serpenspathimg_0E364(self, context):
    sna_updated_prop = self.sna_serpenspathimg
    if bpy.context and bpy.context.screen:
        for a in bpy.context.screen.areas:
            a.tag_redraw()


def sna_update_sna_serpenspathdepth_A977F(self, context):
    sna_updated_prop = self.sna_serpenspathdepth
    if bpy.context and bpy.context.screen:
        for a in bpy.context.screen.areas:
            a.tag_redraw()


def sna_update_sna_statusfloat_A9937(self, context):
    sna_updated_prop = self.sna_statusfloat
    if bpy.context and bpy.context.screen:
        for a in bpy.context.screen.areas:
            a.tag_redraw()


def sna_update_sna_currentstatus_BC932(self, context):
    sna_updated_prop = self.sna_currentstatus
    if (sna_updated_prop == 'Generating Completed successfully'):
        bpy.ops.sna.displace_09ea9()


def find_areas_of_type(screen, area_type):
    areas = []
    for area in screen.areas:
        if area.type == area_type:
            areas.append(area)
    return areas


def find_area_by_type(screen, area_type, index):
    areas = find_areas_of_type(screen, area_type)
    if areas:
        return areas[index]
    return None


def sna_update_sna_planeobject_BBDCB(self, context):
    sna_updated_prop = self.sna_planeobject
    if bpy.context and bpy.context.screen:
        for a in bpy.context.screen.areas:
            a.tag_redraw()


class SNA_PT_AUTODEPTH_AI_8D4A8(bpy.types.Panel):
    bl_label = 'AutoDepth AI'
    bl_idname = 'SNA_PT_AUTODEPTH_AI_8D4A8'
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_context = ''
    bl_category = 'AutoDepth AI'
    bl_order = 0
    bl_ui_units_x=0

    @classmethod
    def poll(cls, context):
        return not (False)

    def draw_header(self, context):
        layout = self.layout

    def draw(self, context):
        layout = self.layout
        box_9A28A = layout.box()
        box_9A28A.alert = False
        box_9A28A.enabled = True
        box_9A28A.active = True
        box_9A28A.use_property_split = False
        box_9A28A.use_property_decorate = False
        box_9A28A.alignment = 'Expand'.upper()
        box_9A28A.scale_x = 1.0
        box_9A28A.scale_y = 1.0
        if not True: box_9A28A.operator_context = "EXEC_DEFAULT"
        col_07CF2 = box_9A28A.column(heading='Info :', align=True)
        col_07CF2.alert = False
        col_07CF2.enabled = True
        col_07CF2.active = True
        col_07CF2.use_property_split = False
        col_07CF2.use_property_decorate = False
        col_07CF2.scale_x = 1.0
        col_07CF2.scale_y = 1.0
        col_07CF2.alignment = 'Expand'.upper()
        col_07CF2.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        box_91F0C = col_07CF2.box()
        box_91F0C.alert = False
        box_91F0C.enabled = True
        box_91F0C.active = True
        box_91F0C.use_property_split = False
        box_91F0C.use_property_decorate = False
        box_91F0C.alignment = 'Expand'.upper()
        box_91F0C.scale_x = 1.0
        box_91F0C.scale_y = 1.0
        if not True: box_91F0C.operator_context = "EXEC_DEFAULT"
        col_74AFD = box_91F0C.column(heading='', align=False)
        col_74AFD.alert = False
        col_74AFD.enabled = True
        col_74AFD.active = True
        col_74AFD.use_property_split = False
        col_74AFD.use_property_decorate = False
        col_74AFD.scale_x = 1.0
        col_74AFD.scale_y = 1.0
        col_74AFD.alignment = 'Expand'.upper()
        col_74AFD.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        row_C5ED3 = col_74AFD.row(heading='', align=False)
        row_C5ED3.alert = False
        row_C5ED3.enabled = True
        row_C5ED3.active = True
        row_C5ED3.use_property_split = False
        row_C5ED3.use_property_decorate = False
        row_C5ED3.scale_x = 1.0
        row_C5ED3.scale_y = 1.0
        row_C5ED3.alignment = 'Expand'.upper()
        row_C5ED3.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        op = row_C5ED3.operator('sna.check_b7cd8', text='Check Installation', icon_value=58, emboss=True, depress=False)
        if (depthgen['sna_check'] == 1):
            row_C5ED3.label(text='Not Installed', icon_value=2)
        else:
            row_C5ED3.label(text='Modules Are Installed', icon_value=36)
        if (depthgen['sna_check'] == 1):
            col_DB293 = col_74AFD.column(heading='', align=False)
            col_DB293.alert = False
            col_DB293.enabled = True
            col_DB293.active = True
            col_DB293.use_property_split = False
            col_DB293.use_property_decorate = False
            col_DB293.scale_x = 1.0
            col_DB293.scale_y = 1.0
            col_DB293.alignment = 'Expand'.upper()
            col_DB293.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            col_DB293.label(text='Run Blender as Administrator to Install Modules', icon_value=751)
        box_91639 = col_07CF2.box()
        box_91639.alert = False
        box_91639.enabled = True
        box_91639.active = True
        box_91639.use_property_split = False
        box_91639.use_property_decorate = False
        box_91639.alignment = 'Expand'.upper()
        box_91639.scale_x = 1.0
        box_91639.scale_y = 1.0
        if not True: box_91639.operator_context = "EXEC_DEFAULT"
        op = box_91639.operator('sna.installdependencies_1d2c8', text='Install Dependencies', icon_value=179, emboss=True, depress=False)
        box_95354 = layout.box()
        box_95354.alert = False
        box_95354.enabled = True
        box_95354.active = True
        box_95354.use_property_split = False
        box_95354.use_property_decorate = False
        box_95354.alignment = 'Expand'.upper()
        box_95354.scale_x = 1.0
        box_95354.scale_y = 1.0
        if not True: box_95354.operator_context = "EXEC_DEFAULT"
        box_256C5 = box_95354.box()
        box_256C5.alert = True
        box_256C5.enabled = True
        box_256C5.active = True
        box_256C5.use_property_split = False
        box_256C5.use_property_decorate = False
        box_256C5.alignment = 'Expand'.upper()
        box_256C5.scale_x = 1.5
        box_256C5.scale_y = 1.5
        if not True: box_256C5.operator_context = "EXEC_DEFAULT"
        row_4FF7C = box_256C5.row(heading='', align=False)
        row_4FF7C.alert = False
        row_4FF7C.enabled = True
        row_4FF7C.active = True
        row_4FF7C.use_property_split = False
        row_4FF7C.use_property_decorate = False
        row_4FF7C.scale_x = 1.0
        row_4FF7C.scale_y = 1.0
        row_4FF7C.alignment = 'Expand'.upper()
        row_4FF7C.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        row_4FF7C.prop(bpy.context.scene, 'sna_enum_set', text=' ', icon_value=0, emboss=True, expand=True)
        if bpy.context.scene.sna_enum_set == "Image To Depth":
            box_34E3C = box_95354.box()
            box_34E3C.alert = False
            box_34E3C.enabled = True
            box_34E3C.active = True
            box_34E3C.use_property_split = False
            box_34E3C.use_property_decorate = False
            box_34E3C.alignment = 'Expand'.upper()
            box_34E3C.scale_x = 1.0
            box_34E3C.scale_y = 1.0
            if not True: box_34E3C.operator_context = "EXEC_DEFAULT"
            if (bpy.context.scene.sna_currentstatus != ''):
                box_164D9 = box_34E3C.box()
                box_164D9.alert = False
                box_164D9.enabled = True
                box_164D9.active = True
                box_164D9.use_property_split = False
                box_164D9.use_property_decorate = False
                box_164D9.alignment = 'Center'.upper()
                box_164D9.scale_x = 1.0
                box_164D9.scale_y = 1.0
                if not True: box_164D9.operator_context = "EXEC_DEFAULT"
                box_164D9.label(text=bpy.context.scene.sna_currentstatus, icon_value=110)
                box_164D9.progress(text=('Current Progress' if (bpy.context.scene.sna_statusfloat < 0.9900000095367432) else 'Completed'), factor=bpy.context.scene.sna_statusfloat, type='RING' if False else 'BAR')
            box_7AB6C = box_34E3C.box()
            box_7AB6C.alert = False
            box_7AB6C.enabled = True
            box_7AB6C.active = True
            box_7AB6C.use_property_split = True
            box_7AB6C.use_property_decorate = False
            box_7AB6C.alignment = 'Expand'.upper()
            box_7AB6C.scale_x = 1.0
            box_7AB6C.scale_y = 1.0
            if not True: box_7AB6C.operator_context = "EXEC_DEFAULT"
            box_C4166 = box_7AB6C.box()
            box_C4166.alert = False
            box_C4166.enabled = True
            box_C4166.active = True
            box_C4166.use_property_split = False
            box_C4166.use_property_decorate = True
            box_C4166.alignment = 'Expand'.upper()
            box_C4166.scale_x = 1.0
            box_C4166.scale_y = 1.0
            if not True: box_C4166.operator_context = "EXEC_DEFAULT"
            box_C4166.prop(bpy.context.scene, 'sna_inputpath', text='Path ', icon_value=0, emboss=False, expand=True)
            box_736C8 = box_C4166.box()
            box_736C8.alert = False
            box_736C8.enabled = (not ((bpy.context.scene.sna_statusfloat > 0.009999999776482582) and (bpy.context.scene.sna_statusfloat < 0.9900000095367432)))
            box_736C8.active = True
            box_736C8.use_property_split = False
            box_736C8.use_property_decorate = False
            box_736C8.alignment = 'Expand'.upper()
            box_736C8.scale_x = 1.2000000476837158
            box_736C8.scale_y = 1.2000000476837158
            if not True: box_736C8.operator_context = "EXEC_DEFAULT"
            op = box_736C8.operator('sna.import_d2dcc', text='Import Image', icon_value=706, emboss=True, depress=False)
            box_2DD25 = box_7AB6C.box()
            box_2DD25.alert = False
            box_2DD25.enabled = True
            box_2DD25.active = True
            box_2DD25.use_property_split = False
            box_2DD25.use_property_decorate = False
            box_2DD25.alignment = 'Expand'.upper()
            box_2DD25.scale_x = 1.0
            box_2DD25.scale_y = 1.0
            if not True: box_2DD25.operator_context = "EXEC_DEFAULT"
            row_BD085 = box_2DD25.row(heading='', align=False)
            row_BD085.alert = False
            row_BD085.enabled = True
            row_BD085.active = True
            row_BD085.use_property_split = False
            row_BD085.use_property_decorate = False
            row_BD085.scale_x = 1.0
            row_BD085.scale_y = 1.0
            row_BD085.alignment = 'Expand'.upper()
            row_BD085.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            box_EAD0B = row_BD085.box()
            box_EAD0B.alert = False
            box_EAD0B.enabled = True
            box_EAD0B.active = True
            box_EAD0B.use_property_split = False
            box_EAD0B.use_property_decorate = False
            box_EAD0B.alignment = 'Expand'.upper()
            box_EAD0B.scale_x = 1.0
            box_EAD0B.scale_y = 1.0
            if not True: box_EAD0B.operator_context = "EXEC_DEFAULT"
            box_EAD0B.template_icon(icon_value=load_preview_icon(bpy.context.scene.sna_abspath), scale=6.0)
            box_0C422 = row_BD085.box()
            box_0C422.alert = False
            box_0C422.enabled = True
            box_0C422.active = True
            box_0C422.use_property_split = False
            box_0C422.use_property_decorate = False
            box_0C422.alignment = 'Expand'.upper()
            box_0C422.scale_x = 1.0
            box_0C422.scale_y = 1.0
            if not True: box_0C422.operator_context = "EXEC_DEFAULT"
            box_0C422.template_icon(icon_value=load_preview_icon(bpy.context.scene.sna_serpenspathdepth), scale=6.0)
            box_B5B5E = box_34E3C.box()
            box_B5B5E.alert = False
            box_B5B5E.enabled = True
            box_B5B5E.active = (not ((bpy.context.scene.sna_statusfloat > 0.009999999776482582) and (bpy.context.scene.sna_statusfloat < 0.9900000095367432)))
            box_B5B5E.use_property_split = True
            box_B5B5E.use_property_decorate = False
            box_B5B5E.alignment = 'Expand'.upper()
            box_B5B5E.scale_x = 1.0
            box_B5B5E.scale_y = 1.0
            if not True: box_B5B5E.operator_context = "EXEC_DEFAULT"
            box_B5B5E.prop(bpy.context.scene, 'sna_planeobject', text='Object :', icon_value=0, emboss=True)
            box_B5B5E.prop(bpy.context.scene, 'sna_serpenspathdepth', text='Depth Path :', icon_value=0, emboss=True)
            box_A2A93 = box_B5B5E.box()
            box_A2A93.alert = False
            box_A2A93.enabled = (not ((bpy.context.scene.sna_statusfloat > 0.009999999776482582) and (bpy.context.scene.sna_statusfloat < 0.9900000095367432)))
            box_A2A93.active = True
            box_A2A93.use_property_split = True
            box_A2A93.use_property_decorate = False
            box_A2A93.alignment = 'Expand'.upper()
            box_A2A93.scale_x = 1.2000000476837158
            box_A2A93.scale_y = 1.2000000476837158
            if not True: box_A2A93.operator_context = "EXEC_DEFAULT"
            op = box_A2A93.operator('sna.generatedepth_9de33', text='Generate Depth', icon_value=421, emboss=True, depress=False)
            if property_exists("bpy.context.scene.sna_planeobject", globals(), locals()):
                box_AC0B9 = box_34E3C.box()
                box_AC0B9.alert = False
                box_AC0B9.enabled = True
                box_AC0B9.active = True
                box_AC0B9.use_property_split = True
                box_AC0B9.use_property_decorate = False
                box_AC0B9.alignment = 'Expand'.upper()
                box_AC0B9.scale_x = 1.0
                box_AC0B9.scale_y = 1.0
                if not True: box_AC0B9.operator_context = "EXEC_DEFAULT"
                box_AC0B9.label(text='Settings :', icon_value=92)
                box_E8A5D = box_AC0B9.box()
                box_E8A5D.alert = False
                box_E8A5D.enabled = True
                box_E8A5D.active = True
                box_E8A5D.use_property_split = True
                box_E8A5D.use_property_decorate = False
                box_E8A5D.alignment = 'Expand'.upper()
                box_E8A5D.scale_x = 1.0
                box_E8A5D.scale_y = 1.0
                if not True: box_E8A5D.operator_context = "EXEC_DEFAULT"
                if property_exists("bpy.context.scene.sna_planeobject.modifiers['displace'].strength", globals(), locals()):
                    box_E8A5D.prop(bpy.context.scene.sna_planeobject.modifiers['displace'], 'strength', text='Strength :', icon_value=0, emboss=True)
                if property_exists("bpy.context.scene.sna_planeobject.modifiers['smooth'].iterations", globals(), locals()):
                    box_E8A5D.prop(bpy.context.scene.sna_planeobject.modifiers['smooth'], 'iterations', text='Smooth :', icon_value=0, emboss=True)
                if property_exists("bpy.context.scene.sna_texture.contrast", globals(), locals()):
                    box_E8A5D.prop(bpy.context.scene.sna_texture, 'contrast', text='Contrast :', icon_value=0, emboss=True)
                if property_exists("bpy.context.scene.sna_texture.extension", globals(), locals()):
                    row_C101A = box_E8A5D.row(heading='Type :', align=True)
                    row_C101A.alert = False
                    row_C101A.enabled = True
                    row_C101A.active = True
                    row_C101A.use_property_split = False
                    row_C101A.use_property_decorate = False
                    row_C101A.scale_x = 1.0
                    row_C101A.scale_y = 1.0
                    row_C101A.alignment = 'Expand'.upper()
                    row_C101A.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                    row_C101A.prop(bpy.context.scene.sna_texture, 'extension', text='Mapping :', icon_value=0, emboss=True, expand=True)
                if property_exists("bpy.context.scene.sna_texture.filter_size", globals(), locals()):
                    box_E8A5D.prop(bpy.context.scene.sna_texture, 'filter_size', text='Gaussian Blur :', icon_value=0, emboss=True, expand=True)
                if property_exists("bpy.context.scene.sna_texture.saturation", globals(), locals()):
                    box_E8A5D.prop(bpy.context.scene.sna_texture, 'saturation', text='Saturation :', icon_value=0, emboss=True, expand=True)
                if property_exists("bpy.context.scene.sna_texture.factor_red", globals(), locals()):
                    row_27ADB = box_E8A5D.row(heading='Multiply :', align=True)
                    row_27ADB.alert = False
                    row_27ADB.enabled = True
                    row_27ADB.active = True
                    row_27ADB.use_property_split = False
                    row_27ADB.use_property_decorate = False
                    row_27ADB.scale_x = 1.0
                    row_27ADB.scale_y = 1.0
                    row_27ADB.alignment = 'Expand'.upper()
                    row_27ADB.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                    row_27ADB.prop(bpy.context.scene.sna_texture, 'factor_red', text='R', icon_value=0, emboss=True, expand=True)
                    row_27ADB.prop(bpy.context.scene.sna_texture, 'factor_green', text='G', icon_value=0, emboss=True, expand=True)
                    row_27ADB.prop(bpy.context.scene.sna_texture, 'factor_blue', text='B', icon_value=0, emboss=True, expand=True)
            op = box_34E3C.operator('sna.displace_09ea9', text='Displace Manually', icon_value=596, emboss=True, depress=False)
        elif bpy.context.scene.sna_enum_set == "Text To Image":
            box_A7E89 = box_95354.box()
            box_A7E89.alert = False
            box_A7E89.enabled = True
            box_A7E89.active = True
            box_A7E89.use_property_split = False
            box_A7E89.use_property_decorate = False
            box_A7E89.alignment = 'Expand'.upper()
            box_A7E89.scale_x = 1.0
            box_A7E89.scale_y = 1.0
            if not True: box_A7E89.operator_context = "EXEC_DEFAULT"
            box_86EED = box_A7E89.box()
            box_86EED.alert = False
            box_86EED.enabled = True
            box_86EED.active = True
            box_86EED.use_property_split = False
            box_86EED.use_property_decorate = False
            box_86EED.alignment = 'Expand'.upper()
            box_86EED.scale_x = 1.0
            box_86EED.scale_y = 1.0
            if not True: box_86EED.operator_context = "EXEC_DEFAULT"
            box_86EED.prop(bpy.context.scene, 'sna_imprompt', text='Prompt', icon_value=0, emboss=True)
            op = box_86EED.operator('sna.text2img_92e65', text='Generate Text to Image', icon_value=0, emboss=True, depress=False)
            box_A7E89.prop(bpy.context.scene, 'sna_serpenspathimg', text='', icon_value=0, emboss=False)
            box_C35EC = box_A7E89.box()
            box_C35EC.alert = False
            box_C35EC.enabled = True
            box_C35EC.active = True
            box_C35EC.use_property_split = False
            box_C35EC.use_property_decorate = False
            box_C35EC.alignment = 'Expand'.upper()
            box_C35EC.scale_x = 1.0
            box_C35EC.scale_y = 1.0
            if not True: box_C35EC.operator_context = "EXEC_DEFAULT"
            if (bpy.context.scene.sna_serpenspathimg != ''):
                box_C35EC.template_icon(icon_value=load_preview_icon(bpy.context.scene.sna_serpenspathimg), scale=10.0)
        else:
            pass


class SNA_OT_Import_D2Dcc(bpy.types.Operator, ImportHelper):
    bl_idname = "sna.import_d2dcc"
    bl_label = "import"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}
    filter_glob: bpy.props.StringProperty( default='*.png;*.jpg;*.exr;*.jpeg;*.psd;*.webp', options={'HIDDEN'} )

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        bpy.context.scene.sna_inputpath = self.filepath
        print(os.path.dirname(bpy.context.scene.sna_abspath), '')
        inputpath = bpy.context.scene.sna_abspath
        basename = os.path.basename(bpy.context.scene.sna_abspath)
        dir = os.path.dirname(bpy.context.scene.sna_abspath)
        # Define the image path
        image_path = inputpath
        image_name = basename
        directory = dir
        # Import the image as a mesh plane
        bpy.ops.image.import_as_mesh_planes(filepath=image_path, files=[{"name":image_name}], directory=directory)
        # Function to find the imported image plane

        def get_imported_image_plane(filepath):
            # Iterate over all objects to find the mesh plane
            for obj in bpy.data.objects:
                # Check if the object is a mesh and its name matches the image file name (excluding extension)
                if obj.type == 'MESH' and obj.name.startswith("img"):
                    return obj
            return None
        # Retrieve the imported mesh plane
        imported_plane = get_imported_image_plane(image_path)
        if imported_plane:
            print(f"Imported mesh plane name: {imported_plane.name}")
            # Access any other relevant data or properties
        else:
            print("No mesh plane was found.")
        bpy.context.view_layer.objects.active.rotation_euler = (1.5700000524520874, 0.0, 0.0)
        bpy.context.view_layer.objects.active.scale = tuple(mathutils.Vector(bpy.context.view_layer.objects.active.scale) * mathutils.Vector((15.0, 15.0, 15.0)))
        if (bpy.context.view_layer.objects.active != None):
            bpy.context.scene.sna_planeobject = bpy.context.view_layer.objects.active
            bpy.ops.sna.viz_961f5('INVOKE_DEFAULT', )
        return {"FINISHED"}


class SNA_OT_Generatedepth_9De33(bpy.types.Operator):
    bl_idname = "sna.generatedepth_9de33"
    bl_label = "GenerateDepth"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        abspath = bpy.context.scene.sna_abspath
        result_output = None
        import sys
        import threading
        # Define module and class names
        module_name = "gradio_client"  # Specify the module name as a string
        class_name = "Client"  # Specify the class name to import
        class_name2 = "handle_file"  # Specify the class name to import
        # Dynamically import the module
        module = importlib.import_module(module_name)
        # Access the class from the module
        Client = getattr(module, class_name)
        handle_file = getattr(module, class_name2)
        inputimage = abspath
        # Define a global variable to store the result
        result_output = None
        # Initialize the status properties
        bpy.context.scene.sna_currentstatus = "Initialized"
        bpy.context.scene.sna_statusfloat = 0.0

        def update_status(new_status, progress=None):
            """Update the sna_currentstatus property and optionally update progress."""
            bpy.context.scene.sna_currentstatus = new_status
            if progress is not None:
                bpy.context.scene.sna_statusfloat = progress
            print(f"Status updated: {new_status}, Progress: {bpy.context.scene.sna_statusfloat}")

        def perform_prediction():
            global result_output
            update_status("Starting Generation...", progress=0.1)
            try:
                # Create the client
                client = Client("Siraitia/Depth-Anything")
                update_status("AI Generating...", progress=0.3)
                # Make the prediction request
                result = client.predict(
                    image=handle_file(inputimage),
                    api_name="/on_submit"
                )
                # Process the result
                first_element = result[0]
                second_file_path = first_element[1]
                bpy.context.scene.sna_serpenspathdepth = second_file_path
                result_output = result
                update_status("Generating Completed successfully", progress=1.0)
                print(result)
            except Exception as e:
                update_status(f"Error during prediction: {e}", progress=0.0)
                print(f"Error: {e}")

        def start_prediction_thread():
            update_status("Starting prediction thread...", progress=0.0)
            # Start the prediction in a separate thread
            prediction_thread = threading.Thread(target=perform_prediction)
            prediction_thread.start()
            update_status("Prediction thread started", progress=0.05)
        # Start the process
        update_status("Script initialized", progress=0.0)
        start_prediction_thread()
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Displace_09Ea9(bpy.types.Operator):
    bl_idname = "sna.displace_09ea9"
    bl_label = "displace"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        modifier_CCBD9 = bpy.context.scene.sna_planeobject.modifiers.new(name='subdivide', type='SUBSURF', )
        bpy.context.scene.sna_planeobject.modifiers['subdivide'].subdivision_type = 'SIMPLE'
        bpy.context.scene.sna_planeobject.modifiers['subdivide'].levels = 6
        bpy.context.scene.sna_planeobject.modifiers['subdivide'].render_levels = 6
        bpy.context.scene.sna_planeobject.modifiers['subdivide'].show_only_control_edges = False
        modifier_65593 = bpy.context.scene.sna_planeobject.modifiers.new(name='displace', type='DISPLACE', )
        bpy.context.scene.sna_planeobject.modifiers['displace'].texture_coords = 'UV'
        texture_1CEC3 = bpy.data.textures.new(name='DepthMap', type='IMAGE', )
        bpy.context.scene.sna_texture = texture_1CEC3
        modifier_65593.texture = texture_1CEC3
        image_F923B = bpy.data.images.load(filepath=bpy.context.scene.sna_serpenspathdepth, check_existing=True, )
        texture_1CEC3.id_data.image = image_F923B
        texture_1CEC3.extension = 'CLIP'
        modifier_E9D4A = bpy.context.scene.sna_planeobject.modifiers.new(name='smooth', type='SMOOTH', )
        bpy.context.scene.sna_planeobject.modifiers['smooth'].iterations = 10
        bpy.context.scene.sna_texture.saturation = 0.0
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


@persistent
def load_post_handler_3CF87(dummy):
    bpy.ops.sna.refreshprogress_9dc2e()


class SNA_OT_Text2Img_92E65(bpy.types.Operator):
    bl_idname = "sna.text2img_92e65"
    bl_label = "text2img"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        imageprompt = bpy.context.scene.sna_imprompt
        result_output = None
        import importlib
        # Define module and class names
        module_name = "gradio_client"  # Specify the module name as a string
        class_name = "Client"  # Specify the class name to import
        class_name2 = "handle_file"  # Specify the class name to import
        # Dynamically import the module
        module = importlib.import_module(module_name)
        handle_file = getattr(module, class_name2)
        # Access the class from the module
        Client = getattr(module, class_name)
        # Define your inputs
        prompt = imageprompt  # Replace with your actual prompt
        negative_prompt = ""  # Replace with your actual negative prompt
        steps = 2
        cfg_scale = 7.0
        seed = 8369697649095
        # Initialize the status properties
        bpy.context.scene.sna_currentstatus = "Initialized"
        bpy.context.scene.sna_statusfloat = 0.0
        # Global lock to prevent scripts from running simultaneously
        execution_lock = threading.Lock()

        def update_status_a(new_status, progress=None):
            """Queue status updates to be run in the main thread."""

            def update():
                bpy.context.scene.sna_currentstatus = new_status
                if progress is not None:
                    bpy.context.scene.sna_statusfloat = progress
                print(f"Status updated: {new_status}, Progress: {bpy.context.scene.sna_statusfloat}")
            # Use a timer to run the update in the main thread
            bpy.app.timers.register(update, first_interval=0)

        def perform_prediction_a():
            update_status_a("Starting Generation...", progress=0.1)
            with execution_lock:  # Lock to prevent simultaneous execution
                try:
                    # Create the client for Prodia's SDXL model
                    client = Client("diffusers/unofficial-SDXL-Turbo-i2i-t2i")
                    result = client.predict(
                        init_image=None,
                        prompt=prompt,
                        strength=0.7,
                        steps=steps,
                        seed=seed,
                        api_name="/predict"
                    )
                    print(result)
                    update_status_a("Image generated successfully", progress=1.0)
                    # Store the final result safely

                    def update_image_path():
                        bpy.context.scene.sna_serpenspathimg = result
                        print("Image path updated:", bpy.context.scene.sna_serpenspathimg)
                    bpy.app.timers.register(update_image_path, first_interval=0)
                except Exception as e:
                    update_status_a(f"Error during prediction: {e}", progress=0.0)
                    print(f"Error: {e}")

        def start_prediction_thread_a():
            update_status_a("Starting prediction thread...", progress=0.0)
            # Start the prediction in a separate thread
            prediction_thread = threading.Thread(target=perform_prediction_a)
            prediction_thread.start()
            update_status_a("Prediction thread started", progress=0.05)
        # Start the process
        update_status_a("Script initialized", progress=0.0)
        start_prediction_thread_a()
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Installdependencies_1D2C8(bpy.types.Operator):
    bl_idname = "sna.installdependencies_1d2c8"
    bl_label = "installdependencies"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        import sys
        from pathlib import Path
        py_exec = str(sys.executable)
        #Get lib directory
        lib = os.path.join(Path(py_exec).parent.parent, "lib")
        #Ensure pip is installed
        subprocess.call([py_exec, "-m", "ensurepip", "--user" ])
        #Update pip (not mandatory)
        subprocess.call([py_exec, "-m", "pip", "install", "--upgrade", "pip" ])
        #Install package
        subprocess.call([py_exec,"-m", "pip", "install", f"--target={str(lib)}", "gradio_client"])
        subprocess.call([py_exec,"-m", "pip", "install", f"--target={str(lib)}", "requests"])
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Check_B7Cd8(bpy.types.Operator):
    bl_idname = "sna.check_b7cd8"
    bl_label = "check"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        NeedInstall = None
        modules_to_check = ["requests", "gradio_client"]  # Replace with the modules you want to check
        NeedInstall = 0 
        for module_name in modules_to_check:
            try:
                __import__(module_name)
                print(f"Module '{module_name}' is installed.")
            except ImportError:
                print(f"Module '{module_name}' is not installed.")
                NeedInstall = 1 
        depthgen['sna_check'] = NeedInstall
        print(str(depthgen['sna_check']))
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Refreshprogress_9Dc2E(bpy.types.Operator):
    bl_idname = "sna.refreshprogress_9dc2e"
    bl_label = "refreshprogress"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        bpy.context.scene.sna_currentstatus = ''
        bpy.context.scene.sna_statusfloat = 0.0
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Viz_961F5(bpy.types.Operator):
    bl_idname = "sna.viz_961f5"
    bl_label = "viz"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        find_area_by_type(bpy.context.screen, 'VIEW_3D', 0).spaces[0].shading.type = 'SOLID'
        find_area_by_type(bpy.context.screen, 'VIEW_3D', 0).spaces[0].shading.light = 'FLAT'
        find_area_by_type(bpy.context.screen, 'VIEW_3D', 0).spaces[0].shading.color_type = 'TEXTURE'
        print(find_area_by_type(bpy.context.screen, 'VIEW_3D', 0).spaces[0].shading.light, find_area_by_type(bpy.context.screen, 'VIEW_3D', 0).spaces[0].shading.type)
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


@persistent
def load_post_handler_CD3C5(dummy):
    bpy.ops.sna.refreshprogress_9dc2e()


class SNA_OT_Refreshprogress_10Efe(bpy.types.Operator):
    bl_idname = "sna.refreshprogress_10efe"
    bl_label = "refreshprogress"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        bpy.context.scene.sna_currentstatus = ''
        bpy.context.scene.sna_statusfloat = 0.0
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


def register():
    global _icons
    _icons = bpy.utils.previews.new()
    bpy.types.Scene.sna_inputpath = bpy.props.StringProperty(name='inputpath', description='', default='', subtype='NONE', maxlen=0, update=sna_update_sna_inputpath_5D51D)
    bpy.types.Scene.sna_abspath = bpy.props.StringProperty(name='abspath', description='', default='', subtype='NONE', maxlen=0)
    bpy.types.Scene.sna_preimage = bpy.props.PointerProperty(name='preimage', description='', type=bpy.types.Image)
    bpy.types.Scene.sna_serpenspathdepth = bpy.props.StringProperty(name='SERPENSPATHDEPTH', description='', options={'TEXTEDIT_UPDATE'}, default='', subtype='FILE_PATH', maxlen=0, update=sna_update_sna_serpenspathdepth_A977F)
    bpy.types.Scene.sna_serpenspathimg = bpy.props.StringProperty(name='SERPENSPATHIMG', description='', options={'TEXTEDIT_UPDATE'}, default='', subtype='FILE_PATH', maxlen=0, update=sna_update_sna_serpenspathimg_0E364)
    bpy.types.Scene.sna_planeobject = bpy.props.PointerProperty(name='PlaneObject', description='', type=bpy.types.Object, update=sna_update_sna_planeobject_BBDCB)
    bpy.types.Scene.sna_depthimage = bpy.props.PointerProperty(name='depthimage', description='', type=bpy.types.Image)
    bpy.types.Scene.sna_imprompt = bpy.props.StringProperty(name='imprompt', description='', default='', subtype='NONE', maxlen=0)
    bpy.types.Scene.sna_enum_set = bpy.props.EnumProperty(name='enum set', description='', items=[('Image To Depth', 'Image To Depth', '', 0, 0), ('Text To Image', 'Text To Image', '', 0, 1)])
    bpy.types.Scene.sna_currentstatus = bpy.props.StringProperty(name='currentstatus', description='', default='Info', subtype='FILE_PATH', maxlen=0, update=sna_update_sna_currentstatus_BC932)
    bpy.types.Scene.sna_statusfloat = bpy.props.FloatProperty(name='statusfloat', description='', default=0.0, subtype='PERCENTAGE', unit='NONE', step=3, precision=6, update=sna_update_sna_statusfloat_A9937)
    bpy.types.Scene.sna_texture = bpy.props.PointerProperty(name='Texture', description='', type=bpy.types.Texture)
    bpy.utils.register_class(SNA_PT_AUTODEPTH_AI_8D4A8)
    bpy.utils.register_class(SNA_OT_Import_D2Dcc)
    bpy.utils.register_class(SNA_OT_Generatedepth_9De33)
    bpy.utils.register_class(SNA_OT_Displace_09Ea9)
    bpy.app.handlers.load_post.append(load_post_handler_3CF87)
    bpy.utils.register_class(SNA_OT_Text2Img_92E65)
    bpy.utils.register_class(SNA_OT_Installdependencies_1D2C8)
    bpy.utils.register_class(SNA_OT_Check_B7Cd8)
    bpy.utils.register_class(SNA_OT_Refreshprogress_9Dc2E)
    bpy.utils.register_class(SNA_OT_Viz_961F5)
    bpy.app.handlers.load_post.append(load_post_handler_CD3C5)
    bpy.utils.register_class(SNA_OT_Refreshprogress_10Efe)
    translate.register()

def unregister():
    global _icons
    bpy.utils.previews.remove(_icons)
    wm = bpy.context.window_manager
    kc = wm.keyconfigs.addon
    for km, kmi in addon_keymaps.values():
        km.keymap_items.remove(kmi)
    addon_keymaps.clear()
    del bpy.types.Scene.sna_texture
    del bpy.types.Scene.sna_statusfloat
    del bpy.types.Scene.sna_currentstatus
    del bpy.types.Scene.sna_enum_set
    del bpy.types.Scene.sna_imprompt
    del bpy.types.Scene.sna_depthimage
    del bpy.types.Scene.sna_planeobject
    del bpy.types.Scene.sna_serpenspathimg
    del bpy.types.Scene.sna_serpenspathdepth
    del bpy.types.Scene.sna_preimage
    del bpy.types.Scene.sna_abspath
    del bpy.types.Scene.sna_inputpath
    bpy.utils.unregister_class(SNA_PT_AUTODEPTH_AI_8D4A8)
    bpy.utils.unregister_class(SNA_OT_Import_D2Dcc)
    bpy.utils.unregister_class(SNA_OT_Generatedepth_9De33)
    bpy.utils.unregister_class(SNA_OT_Displace_09Ea9)
    bpy.app.handlers.load_post.remove(load_post_handler_3CF87)
    bpy.utils.unregister_class(SNA_OT_Text2Img_92E65)
    bpy.utils.unregister_class(SNA_OT_Installdependencies_1D2C8)
    bpy.utils.unregister_class(SNA_OT_Check_B7Cd8)
    bpy.utils.unregister_class(SNA_OT_Refreshprogress_9Dc2E)
    bpy.utils.unregister_class(SNA_OT_Viz_961F5)
    bpy.app.handlers.load_post.remove(load_post_handler_CD3C5)
    bpy.utils.unregister_class(SNA_OT_Refreshprogress_10Efe)
    translate.unregister()
